Index: dlls/setupapi/devinst.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/devinst.c,v
retrieving revision 1.14
diff -u -r1.14 devinst.c
--- dlls/setupapi/devinst.c	8 Sep 2003 19:38:46 -0000	1.14
+++ dlls/setupapi/devinst.c	10 Sep 2003 01:44:25 -0000
@@ -22,11 +22,13 @@
 
 #include "windef.h"
 #include "winbase.h"
-#include "wine/debug.h"
 #include "wingdi.h"
 #include "winuser.h"
 #include "winnls.h"
+#include "winreg.h"
 #include "setupapi.h"
+#include "wine/debug.h"
+
 
 WINE_DEFAULT_DEBUG_CHANNEL(setupapi);
 
Index: dlls/setupapi/infparse.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/infparse.c,v
retrieving revision 1.19
diff -u -r1.19 infparse.c
--- dlls/setupapi/infparse.c	8 Sep 2003 19:38:46 -0000	1.19
+++ dlls/setupapi/infparse.c	10 Sep 2003 01:44:25 -0000
@@ -27,16 +27,15 @@
 
 #include <stdarg.h>
 #include <string.h>
+
 #include "windef.h"
 #include "winbase.h"
 #include "winreg.h"
 #include "winternl.h"
-#include "wine/winbase16.h"
 #include "wingdi.h"
 #include "winuser.h"
 #include "winnls.h"
 #include "setupapi.h"
-#include "setupx16.h"
 #include "setupapi_private.h"
 #include "wine/debug.h"
 
Index: dlls/setupapi/install.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/install.c,v
retrieving revision 1.7
diff -u -r1.7 install.c
--- dlls/setupapi/install.c	5 Sep 2003 23:08:32 -0000	1.7
+++ dlls/setupapi/install.c	10 Sep 2003 01:44:26 -0000
@@ -29,8 +29,8 @@
 #include "winuser.h"
 #include "winnls.h"
 #include "setupapi.h"
-#include "wine/unicode.h"
 #include "setupapi_private.h"
+#include "wine/unicode.h"
 #include "wine/debug.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(setupapi);
Index: dlls/setupapi/parser.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/parser.c,v
retrieving revision 1.8
diff -u -r1.8 parser.c
--- dlls/setupapi/parser.c	5 Sep 2003 23:08:31 -0000	1.8
+++ dlls/setupapi/parser.c	10 Sep 2003 01:44:30 -0000
@@ -29,15 +29,15 @@
 
 #include "windef.h"
 #include "winbase.h"
-#include "winreg.h"
-#include "winternl.h"
-#include "winerror.h"
-#include "wine/unicode.h"
 #include "wingdi.h"
 #include "winuser.h"
 #include "winnls.h"
+#include "winreg.h"
+#include "winternl.h"
+#include "winerror.h"
 #include "setupapi.h"
-#include "setupx16.h"
+
+#include "wine/unicode.h"
 #include "wine/debug.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(setupapi);
Index: dlls/setupapi/queue.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/queue.c,v
retrieving revision 1.7
diff -u -r1.7 queue.c
--- dlls/setupapi/queue.c	5 Sep 2003 23:08:31 -0000	1.7
+++ dlls/setupapi/queue.c	10 Sep 2003 01:44:33 -0000
@@ -31,7 +31,7 @@
 #include "setupapi.h"
 #include "wine/unicode.h"
 #include "setupapi_private.h"
-#include "ver.h"
+#include "winver.h"
 #include "wine/debug.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(setupapi);
Index: dlls/setupapi/setupcab.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/setupcab.c,v
retrieving revision 1.2
diff -u -r1.2 setupcab.c
--- dlls/setupapi/setupcab.c	5 Sep 2003 23:08:31 -0000	1.2
+++ dlls/setupapi/setupcab.c	10 Sep 2003 01:44:35 -0000
@@ -26,11 +26,14 @@
 #include <stdarg.h>
 #include "string.h"
 #include "stdlib.h"
+
+#include "wine/debug.h"
 #include "windef.h"
 #include "winbase.h"
 #include "wingdi.h"
 #include "winuser.h"
 #include "winnls.h"
+#include "winreg.h"
 #include "setupapi.h"
 #include "setupapi_private.h"
 #include "fdi.h"
Index: dlls/setupapi/stubs.c
===================================================================
RCS file: /home/wine/wine/dlls/setupapi/stubs.c,v
retrieving revision 1.13
diff -u -r1.13 stubs.c
--- dlls/setupapi/stubs.c	5 Sep 2003 23:08:31 -0000	1.13
+++ dlls/setupapi/stubs.c	10 Sep 2003 01:44:35 -0000
@@ -26,6 +26,7 @@
 #include "wingdi.h"
 #include "winuser.h"
 #include "winnls.h"
+#include "winreg.h"
 #include "setupapi.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(setupapi);